#!/usr/bin/perl
#  Copyright 2001-2011 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Eoy' => 'Eoy',
	   'Configuration' => 'Configuration',
	   'Error' => 'Error',
	   'Update' => 'Update',
	   'Main' => 'Main',
	   'Table' => 'Table',
	   'New' => 'New',
	   'Not Found' => 'Not Found',
	   'Attribute' => 'Attribute',
	   'Value' => 'Value',
	   'Deleted' => 'Deleted',

	   'No' => 'No',
	   'Add' => 'Add',
	   'Delete' => 'Delete',
	   'Variable' => 'Variable',

	   );

my $self = 'confupdate_db.pl';

# Fields to update in the existing conf_system table.
my @confFields = qw( sectionname sequenceval version description );


use DBI;
use CGI;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Page Header
print "$doctype\n<html><head><title>$lex{Update} $lex{Configuration} - $lex{Table}</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "<style type=\"text/css\">td.ra { text-align:right;font-weight:bold;}</style>\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">$lex{Main}</a> | <a href=\"$eoypage\">$lex{Eoy}</a> ]\n";
print "<h1>$lex{Update} $lex{Configuration} - $lex{Table}</h1>\n";

# Not designed for command line
#if ( not @ARGV ) {
#    print "Usage: confupdate_db.pl sourcetable destinationtable\n";
#    exit;
#}
#my ($sourcetable, $desttable ) = @ARGV;
#print "Source: $sourcetable Destination: $desttable\n";
#exit;


# Check to see if the temp_conf_system exists
# Better method for later.
#SELECT COUNT(*)
#FROM information_schema.tables 
#WHERE table_schema = '[database name]' 
#    AND table_name = '[table name]';

# Check if temp_conf_system exists.
my $sth = $dbh->prepare("show tables like 'temp_conf_system'");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $test = $sth->fetchrow;
if ( not $test ) {
    print "<h3>$lex{Configuration} $lex{Update} (temp_conf_system) $lex{'Not Found'}</h3>\n";
    print "</body></html>\n";
    exit;
}

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<form action=\"$self\" method=\"post\">\n";

print "<tr><td><input type=\"checkbox\" name=\"attrib\" value=\"1\">\n";
print "$lex{Update} $lex{Attribute}</td></tr>\n";

print "<tr><td><input type=\"checkbox\" name=\"add\" value=\"1\">\n";
print "$lex{Add} $lex{'Record(s)'}</td></tr>\n";

print "<tr><td><input type=\"checkbox\" name=\"delete\" value=\"1\">\n";
print "$lex{Delete} $lex{'Record(s)'}</td></tr>\n";

print "<tr><td style=\"text-align:center;\">";
print "<input type=\"submit\" value=\"$lex{Update}\"></td></tr>\n";
print "</form></table>\n";


# Load both tables into hashes.
my ($ref, $tempref);
$sth = $dbh->prepare("select * from conf_system"); 
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$ref = $sth->fetchall_hashref( 'dataname' );


$sth = $dbh->prepare("select * from temp_conf_system"); 
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$tempref = $sth->fetchall_hashref( 'dataname' );




# Update any Record Fields
print "<h3>$lex{Update} $lex{Variable} $lex{Attribute}</h3>\n";

my $first = 1;

foreach my $key ( keys %$tempref ) {

    if ( not $ref->{$key} ) { # skip if no matching field in original
	next; 
    } 

    # records are in $tempref->{$key} and $ref->{$key}
    # First Update the Fields
    my $count;

    foreach my $fld ( @confFields ) {

	# $count++;
	# print "$count. K:$key  F:$fld  Val:$tempref->{$key}->{$fld}<br><b>$ref->{$key}->{$fld}</b><br>\n";

	if ( $tempref->{$key}->{$fld} eq $ref->{$key}->{$fld} ) {
	    next; 
	}

	# Update the main record
	$sth = $dbh->prepare("update conf_system set $fld = ? where id = ?");
	if ( $arr{attrib} ) {
	    #print "Update Attribute<br>\n";
	    $sth->execute( $tempref->{$key}->{$fld}, $ref->{$key}->{id} );
	}
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	if ( $first ) { # print table start
	    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	    print "</tr><th>$lex{Variable}</th><th>$lex{Attribute}</th><th>$lex{New} $lex{Value}</th></tr>\n";
	    $first = 0;
	}

	print "<tr><td>$key</td><td>$fld</td><td>$tempref->{$key}->{$fld}</td></tr>\n";

    }

    # Now erase the 2 values if identical keys (dataname) (for later record comparisons)
    if ( $tempref->{$key} and $ref->{$key} ) {
	delete $tempref->{$key};
	delete $ref->{$key};
    }

}

if ( $first ) { # no changes found.
    print "<p>$lex{No} $lex{Attribute} $lex{Update}</p>\n";

} else { # end the table.
    print "</table>\n";
}




# Delete Records (vars)
print "<h3>$lex{Delete} $lex{Variable}</h3>\n";

$first = 1;

$sth = $dbh->prepare("delete from conf_system where id = ?");

foreach my $key ( sort keys %$ref ) {

    if ( $arr{delete} ) {
	# print "Delete Variables<br>\n";
	$sth->execute( $ref->{$key}->{id} );
    }

    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    if ( $first ) {
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "</tr><th>$lex{Variable}</th><th>$lex{Value}</th></tr>\n";
	$first = 0;
    }

    print "<tr><td>$key</td><td>$ref->{$key}->{datavalue}</td></tr>\n";
}

if ( $first ) {
    print "<p>$lex{No} $lex{Delete} $lex{Variable}</p>\n";
} else {
    print "</table>\n";
}




# Add Records (vars)
print "<h3>$lex{Add} $lex{Variable}</h3>\n";

$first = 1;

foreach my $key ( sort keys %$tempref ) {

    my %temp = %{ $tempref->{$key} };
    delete $temp{id};

    my $keystring = join(',', keys %temp );
    my @vals = values %temp;
    # print "K:$keystring V:@vals<br>\n";

    if ( $arr{add} ) {
	# print "Add Variable<br>\n";
	$sth = $dbh->prepare("insert into conf_system ( $keystring ) values ( ?,?,?,?,?,?,?,?,? )");
	$sth->execute( @vals );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    }

    if ( $first ) {
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "</tr><th>$lex{Variable}</th><th>$lex{Value}</th></tr>\n";
	$first = 0;
    }

    print "<tr><td>$key</td><td>$tempref->{$key}->{datavalue}</td></tr>\n";

}

if ( $first ) {
    print "<p>$lex{No} $lex{Add} $lex{Variable}</p>\n";
} else {
    print "</table>\n";
}

print "</body></html>\n";
