#!/usr/bin/perl
#  Copyright 2001-2017 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Reserve Resident Students' => 'Reserve Resident Students',
	   'Main' => 'Main',
	   'Native Bands' => 'Native Bands',
	   'Band Name' => 'Band Name',
	   'Band Number' => 'Band Number',
	   'Grade' => 'Grade',
	   'Student' => 'Student',
	   'Reserve' => 'Reserve',
	   'Parents' => 'Parent(s)',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


# Page Header
my $title = $lex{'Reserve Resident Students'};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">\n};
print qq{$chartype\n</head><body><a name="top"></a>\n};

print qq{[ <a href="$homepage">$lex{Main}</a> ]\n};

print qq{<h1>$title</h1><h3>$currdate</h3>\n};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

print qq{<table border="1" cellpadding="3" cellspacing="0">\n};
print qq{<caption style="font-size:120%;">$title</caption>\n};
print qq{<tr><th>$lex{'Band Name'}</th><th>$lex{'Band Number'}</th></tr>\n};

$sth = $dbh->prepare("select distinct band, bandnum from student order by band");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my($bandname,$bandnumber) = $sth->fetchrow){
    print qq{<tr><td>$bandname</td><td>$bandnumber</td></tr>\n};
}
print qq{</table><p></p>\n};


my $select = "where reserveres != 'On'";
my $sortby = 'grade, lastname, firstname';

$sth = $dbh->prepare("select lastname, firstname, initial, studnum,
  birthdate, treaty, band, bandnum, name1, name2, grade from student $select
  order by $sortby");

$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

$currgrade = -1;
$firstflag = 1;

while ( my ($lastname, $firstname, $initial, $studnum, $birthdate, $treaty,
	    $band, $bandnum, $name1, $name2, $grade) = $sth->fetchrow ) {

    $oldgrade = $currgrade;
    $currgrade = $grade;

    if ($oldgrade ne $currgrade) { # we have a new grade
	if (not $firstflag){ print qq{</table><p></p>\n}; } else { $firstflag = 0; }
	print qq{<table border="1" cellpadding="3" cellspacing="0">\n};

	print qq{<caption><b>$lex{Grade} $currgrade</b></caption>\n};
	print qq{<tr><th>$lex{Student}</th><th>$lex{Reserve}</th>\n};
	print qq{<th>$lex{Parents}</th></tr>\n};
    }

    print qq{<tr><td><b>$lastname</b>, $firstname $initial<br>};
    print qq{$birthdate ($studnum)</td>\n};
    # Student name (1,2,3) Student num (4) and birthdate (8)

    print qq{<td>$treaty<br>$band $bandnum</td>\n};
    # Treaty number (unique), Band Name, Band number

    print qq{<td>$name1<br>$name2</td></tr>\n};
    # Name1 and Name2 fields

} # End of Main Loop

print qq{</table>[ <a href="#top">Top</a> ]</body></html>\n};
