#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson
#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $g_ldapgidnumber = 50; # used to populate the ldap_gidnumber value.


%lex = ( 'Main' => 'Main',
	 'Eoy' => 'Eoy',
	 'Unable to open' => 'Unable to open',
	 'Template' => 'Template',
	 'Staff Member' => 'Staff Member',
	 'Add' => 'Add',
	 'Eoy' => 'Eoy',
	 'Required' => 'Required',
	 'Bold' => 'Bold',
	 'Error' => 'Error',
	 'Preregistration' => 'Preregistration',
	 'Record(s) Stored' => 'Record(s) Stored',
	 'Position' => 'Position',
	 'Grade' => 'Grade',
	 'Homeroom' => 'Homeroom',
	 'Separate with Spaces' => 'Separate with Spaces',
	 'User Id' => 'User Id',
	 'Exists' => 'Exists',
	 'Password' => 'Password',
	 'Contact' => 'Contact',

	 );

use CGI;
use DBI;

my $self = 'maketemplate.pl';


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../lib/libmeta.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;



my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Print Page Header
print "$doctype\n<html><head><title>\n";
print $lex{Add}. q{ }. $lex{'Staff Member'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "<style type=\"text/css\">.ra { text-align:right; }</style>\n";

print "$chartype\n</head><body>[ <a href=\"$homepage\">";
print $lex{Main}, "</a> | <a href=\"$eoypage\">";
print $lex{Eoy}, "</a> ]<h1>";

print $lex{Add}. q{ }. $tableview. "</h1>\n";


# Open File for Template Creation
my $templatename = "template$$.tpl";

unless (open (FH,">$templatename")) {
    print $lex{'Unable to open'}. q{ }. $lex{Template},": $!\n";
    die $lex{'Unable to open'}. q{ }. $lex{Template},": $!\n";
}

# Next read in fieldnames from meta
my $sth = $dbh->prepare("select fieldid from meta where tableid = ? order by arrayidx");
$sth->execute( 'staff' );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while ( my ( $fieldid, $fieldname, $required ) = $sth->fetchrow ) {
    print FH "<*$fieldid*> <". '@'. $fieldid. '@'. ">\\\\\n";
}

close FH;
exit;





if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeRecord();
}

print "<p><b>". $lex{Bold}. "</b> = ". $lex{Required}. "</p>\n";


# Read in Template
unless (open (FH,"<../../template/staff.tpl")) {
    print $lex{'Unable to open'}. q{ }. $lex{Template},": $!\n";
    die $lex{'Unable to open'}. q{ }. $lex{Template},": $!\n";
}
my $formtext;
{ local $/; $formtext = <FH>; close FH;}


# Create hash for fieldnames from meta.
my $sth = $dbh->prepare("select fieldid, fieldname, required from meta where tableid = ?");
$sth->execute( 'staff' );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my %fieldnames = ();
while ( my ( $fieldid, $fieldname, $required ) = $sth->fetchrow ) {
    if ( $required ) { # has any value
	$fieldname = "<span style=\"font-weight:bold;\">$fieldname</span>";
    }
    $fieldnames{$fieldid} = $fieldname;
}

# Now put replacement text back in.
$formtext =~ s{\<\*(.*?)\*\>}
  { exists( $fieldnames{$1} ) 
	? $fieldnames{$1} 
	: $1
  }gsex;


# Find all field values, so we only wrap forms around them (typically
# faster than doing all fields in the table )
my @fields = ();
while ( $formtext =~ m/\<\@(.*)\@\>/g){
    push @fields, $1;
}

my %rec = ();

# Get Largest Uidnumber.
foreach my $table ( qw( staff student )) {
    my $sth = $dbh->prepare("select max(ldap_uidnumber) from $table");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $uidnumber = $sth->fetchrow;
    if ( $uidnumber > $maxuidnumber ) {
	$maxuidnumber = $uidnumber;
    }
}
$maxuidnumber++; # increment for next one.


# Now set password, other config values at top of script
my $pwd = word( $g_studentpwd_genlen, $g_studentpwd_maxlen,
		$g_studentpwd_lang, $g_studentpwd_signs,
		$g_studentpwd_caps, $g_studentpwd_minfreq,
		$g_studentpwd_avgfreq );


$rec{password} = $pwd;
$rec{ldap_gidnumber} = $g_ldapgidnumber; # at top of file...
$rec{ldap_uidnumber} = $maxuidnumber;



# get replacement values for fields
my %values = ();
foreach my $fieldid ( @fields ) {
    $values{$fieldid} = metaInputField(
	'staff',$fieldid, $rec{ $fieldid }, $dbh,'' ); # no passed value, no preheader

}



# now put field values back into $formtext variable...
$formtext =~ s{ \<\@(.*?)\@\> }
  { exists($values{$1}) 
	? $values{$1} 
	: "$values{$1}-$1"
  }gsex;


# print top of form, then $text, then bottom of page.
print "<form action=\"$self\" method=\"post\"> 
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

if ( $table eq 'prereg_staff' ) {
    print "<input type=\"hidden\" name=\"tbl\" value=\"prereg\">\n";
}

print $formtext,"\n";

# Now do the position, homeroom, and grade multivalues.
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" style=\"float:left;margin:0 2em;\">\n";
for my $i (1 .. $maxmulti ) {
    print "<tr><td class=\"ra\">". $lex{Position}. " $i</td><td><select name=\"position$i\"><option></option>\n";
    foreach my $pos ( @g_position ) { print "<option>$pos</option>"; }
    print "\n</select></td></tr>\n";
}


print "<tr><td class=\"ra\">". $lex{Grade}. "</td><td><input type=\"text\" name=\"grade\" size=\"12\"> ";
print $lex{'Separate with Spaces'}. "</td></tr>\n";
print "<tr><td class=\"ra\">". $lex{Homeroom}. "</td><td><input type=\"text\" name=\"homeroom\" size=\"12\"> ";
print $lex{'Separate with Spaces'}. "</td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\" style=\"background-color:#DDD;\"><input type=\"submit\" value=\"";
print $lex{Add}. q{ }. $lex{'Staff Member'}. "\"></td></tr>\n";

print "</table>\n";
print "</form></body></html>\n";


#--------------
sub userid2uid { # function to convert a staff userid field value to the ldap_uid value
#--------------

    my $userid = shift;

    return $userid;

}


#--------------
sub writeRecord {
#--------------

    # foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    
    # Make sure we have userid, password.
    if ( not $arr{userid} or not $arr{password} ) {
	print "<h1>". $lex{Required}. ': ', $lex{'User Id'}. ','. $lex{Password};
        print "</h1></body></html>\n";
	exit;
    }

    # Make sure userid doesn't already exist...else warn.
    $sth = $dbh->prepare("select count(*) from $table where userid = ?");
    $sth->execute( $arr{userid} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    if ( my $count = $sth->fetchrow ) {
	print "<h1>". $lex{Error}. ': ',  $lex{'User Id'}. q{ }. $lex{Exists};
	print "</body></html>\n";
	exit;
    }

    # Check for password quality using Data::Password module.
    $MINLEN = $g_staffpwd_minlen;  # from admin.conf settings.
    $MAXLEN = $g_staffpwd_maxlen;
    $FOLLOWING = $g_staffpwd_following;
    $GROUPS = $g_staffpwd_groups;
    if ( $g_staffpwd_dictionary ) {
	$DICTIONARY = $g_staffpwd_dictionary;
    } else {
	$DICTIONARY = 0; # turn it off.
    }

    if ( IsBadPassword( $arr{password} )) {
	print "<h1 style=\"color:red;\">". $lex{Password}. q{ }. $lex{Error}. "<br>\n";
	print IsBadPassword( $arr{password} );
	print "</h1></body></html>\n";
	exit;
    }


    # remove multi values from %arr;
    my $grade = $arr{grade};
    delete $arr{grade}; 
    my $homeroom = $arr{homeroom};
    delete $arr{homeroom};
    for my $i ( 1 .. $maxmulti ) {
	$position{$i} = $arr{"position$i"};
	delete $arr{"position$i"};
    }

#    foreach my $key ( sort keys %position) { print "K:$key V:$position{$key}<br>\n"; }
#    foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


    my @values = ();
    my @fieldnames = ();

    # push in the passed values (skip blanks since an add process)
    foreach my $key ( sort keys %arr ) { # run through all passed values.
	if ( $arr{$key} ) {    # if we have a value
	    push @values, $arr{$key};
	    push @fieldnames, $key;
	}
    }


    # Set LDAP User Id; Function used in case something tricky wanted, later.
    my $uid = userid2uid( $arr{userid} );
    push @values, $uid;
    push @fieldnames, 'ldap_uid';



    # Join values
    my $fields = join(',', @fieldnames );
    foreach my $val ( @values ) {
	$val = $dbh->quote( $val );
    }
    my $values = join(',', @values );


    # print "Insert Fields: $fields  Values: $values<br>\n";
    $sth = $dbh->prepare("insert into $table ( $fields ) values( $values )");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # now add the multirecord values.
    $sth = $dbh->prepare("insert into $multitable ( userid, field_name, field_value ) 
      values( ?, ?, ? )");

    my @grades = split / /, $grade;
    foreach my $grade ( @grades ) {
	$sth->execute( $arr{userid}, 'grade', $grade );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    my @hroom = split / /, $homeroom;
    foreach my $hr ( @hroom ) {
	$sth->execute( $arr{userid}, 'homeroom', $hr );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    for my $i ( 1 .. $maxmulti ) {
	if ( $position{$i} ) { # we have a position value
	    $sth->execute( $arr{userid}, 'position', $position{$i} );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	}
    }

    if (not $DBI::errstr ) {
	print "<h3>";
	print $lex{'Record(s) Stored'};
	print ".</h3></p>";
    } else {
	print "<h3>".$lex{Error}. q{ };
	print $lex{Contact}. " $adminname - ";
	print "<a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print " $DBI::errstr";
	print "</h3>\n";
    }

    print "<p>[ <a href=\"$homepage\">".$lex{Main}."</a> | <a href=\"$eoypage\">";
    print $lex{Eoy}. "</a> | \n";

    if ( $table ne 'staff' ) {
	print "<a href=\"$self?tbl=prereg\">";
	print $lex{Add}. "<span style=\"color:red;\">". $lex{Preregistration}; 
	print "</span> ". $lex{'Staff Member'}."</a> ]\n";
    } else {
	print "<a href=\"$self\">". $lex{Add}. q{ }. $lex{'Staff Member'};
	print "</a> ]\n";
    }
    print "</p></center></body></html>\n";

    exit;

}
