<!DOCTYPE html>
<!--
#  Copyright 2001-2021 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.
-->

<html><head><title>Open Admin - <#Report Card System#></title>
<link rel="stylesheet" href="admin.css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
 form, input, button, select { padding:0; margin:0;font-size:100%; }
</style>
</head><body>

<ul class="nav" style="border-top:1px solid black; margin: 0.5em; 
 position: fixed; top:0; bottom:auto;">
<li><a href="index.shtml"><#Main#></a></li>
<li><a href="attendance.html"><#Attendance#></a></li>
<li><a href="discipline.html"><#Discipline#></a></li>
<li><a href="fees.html"><#Fees#></a></li>
<li class="active"><a href="repcard.html" class="active"><#Report Cards#></a></li>
<li><a href="timetable.html"><#Timetable#></a></li>
<li><a href="export.html"><#Export/Xfer#></a></li>
<li><a href="eoy.html"><#Start/End of Year#></a></li>
<li><a href="ssp.html"><#SSP#></a></li>
</ul>
<div style="height:24px;"></div>

<table cellpadding="4" cellspacing="0" border="0">
<tr><td valign="top">
<!-- ========== Left Column ===============  -->

<table cellpadding="0" cellspacing="0" border="0">
<tr><td><img src="images/logotn.gif" alt="logo"></td>
<td><hr><h1 style="padding:0;margin:0;"><#Report Card System#></h1><hr>
</td></tr></table>

<h2><#Mark Entry#> <#Term#></h2>

<iframe src="/cgi-bin/repcard/termview.pl"  height="75" frameborder="0">Inline Frame not supported</iframe>

<div style="padding:0em 2em 0.4em 1em;">
<form action="/cgi-bin/repcard/termmarkentry.pl" method="post" style="display:inline;"
title="<#Setting the term to 1 forces entry to term 1 marks, etc.  Setting #>
<#the term to 0 will inactivate mark entry on the teacher site. This #>
<#might be a good idea until a week or so before report cards are due.#>">
<input type="submit" value="<#Set#> <#Mark Entry#> <#Term#>"></form></div>

<h2><#Report Cards#> / <#Mark Sheets#></h2>

<div style="margin:0.6em;padding:0.5em;border:1px solid gray;text-align:center;background-color:#ACF;">
<form action="/cgi-bin/repcard/rptrepcard.pl" method="post" style="display:inline;">
<input type="submit" value="<#Print Report Cards#>">
</form></div>

<div class="fmt">
<form action="/cgi-bin/repcard/checkmark.pl" method="post" style="display:inline;">
  <input type="submit" value="<#Missing#> <#Marks#> <#Check#>"
	 title="Detect if any mark entry has been missed for the current term before printing report cards">
</form>

<span style="font-weight:bold;"><a href="/reportcard">Previous Year Report Cards</a></span>

</div>

<div class="fmt"><#Report#> <#by#>
<form action="/cgi-bin/repcard/rpt_term_mark.pl" method="post" style="display:inline;">
<input type="submit" value="<#Course#>"
title="Term Marks grouped by course or grade, sorted by grade, teacher, course"></form>

<form action="/cgi-bin/repcard/rpt_term_mark_stud.pl" method="post" style="display:inline;">
<input type="submit" value="<#Student#>" 
title="Useful during Parent-Teacher Interviews. Multiple student blocks per page">
</form>

<form action="/cgi-bin/repcard/exporteval.pl" method="post" style="display:inline;">
<input type="submit" value="<#Export#>" 
       title="Export Evaluations to Spreadsheet CSV for further complex reporting">
</form>
</div>


<div class="fmt">
<form action="/cgi-bin/repcard/rptsummxtab.pl" method="post" style="display:inline;">
<input type="submit" value="<#Crosstab#> <#Marks#>" 
title="A summary crosstab report showing all subjects and objective eval results for student  for term">
</form>

<form action="/cgi-bin/repcard/rptrank.pl" method="post" style="display:inline;">
<input type="submit" value="<#GPA Ranking#>"
title="Rank by class or entire student body"></form>
</div>


<div class="fmt">
<#Year End#> 
<form action="/cgi-bin/repcard/rptfinalsumm.pl" method="post" style="display:inline;">
<input type="submit" value="<#Grade#>"
title="<#A one page summary of all marks for one grade#>">
</form>

<form action="/cgi-bin/repcard/rptfinalstud.pl" method="post" style="display:inline">
<input type="submit" value="<#Student#>"
title="<#A single page per student report containing their final marks#>. 
<#Useful for insertion into cumes#>">
</form>
</div>


</td><td valign="top"> <!--  === The Right Column === -->


<h2><#Transcripts#></h2>

<div class="fmt">
<form action="/cgi-bin/repcard/rpttranscript.pl" method="post" style="display:inline;">
<input type="submit" value="<#View/Print Transcripts#>"></form>

<form action="/cgi-bin/repcard/tscpost.pl" method="post" style="display:inline;">
<input type="submit" value="<#Post Term Marks#>"></form>

<form action="/cgi-bin/repcard/tscdeled.pl" method="post" style="display:inline;">
<input type="submit" value="<#Edit/Delete#>"></form>

<form action="/cgi-bin/repcard/tscadd.pl" method="post" style="display:inline;">
<input type="submit" value="<#Add#>"></form>
</div>

<h2><#Course#> <#Masters#></h2>

<div class="fmt">
<form action="/cgi-bin/repcard/subjadd.pl" method="post" style="display:inline;">
<input type="submit" value="<#New#> <#Course#>"></form>

<form action="/cgi-bin/repcard/subjdeled.pl" method="post" style="display:inline;">
<input type="submit" value="<#Edit#>/<#Delete#>"></form>

<form action="/cgi-bin/repcard/coursemstreset.pl" method="post" style="display:inline;">
<input type="submit" value="<#Reset#>"></form>
<br>

<form action="/cgi-bin/repcard/rptcoursemst1.pl" method="post" style="display:inline;">
  <input type="submit" title="Courses by Teacher, Term" value="CM <#Report#> 1"></form>

<form action="/cgi-bin/repcard/rptcoursemst2.pl" method="post" style="display:inline;">
<input type="submit" title="Courses by Grade, Term" value="CM <#Report#> 2"></form>

<form action="/cgi-bin/repcard/rptcoursemst3.pl" method="post" style="display:inline;">
<input type="submit" title="Courses by Teacher" value="CM <#Report#> 3"></form>
<br>
<div style="font-weight:bold;">Pre-plan Course Offerings</div>
<form action="/cgi-bin/sasked/preplancoursemaster.pl" method="post" style="display:inline;">
  <input type="submit" title="Start to Pre-plan Course Offerings for next year for grades 10-12"
	 value="Start - Page 1"></form>

<form action="/cgi-bin/sasked/preplancoursemaster.pl" method="post" style="display:inline;">
  <input type="submit" title="Start to Pre-plan Course Offerings for next year for grades 10-12"
	 value="Reset Course Values - Page 3">
  <input type="hidden" name= "page" value="2">
</form>

<form action="/cgi-bin/configure/confedit.pl" method="post"  style="display:inline;">
  <input type="hidden" name="filename" value="admin">
  <input type="hidden" name="sectionname" value="preplan">
  <input type="hidden" name="page" value="1">
  <input type="submit" value="Configure">
</form>



<span style="font-weight:bold;color:red;">New!</span>
</div>


<h2><#Course#> <#Enrollment#></h2>

<div class="fmt">
<form action="/cgi-bin/repcard/enroladdall.pl" method="post" style="display:inline;">
<input type="submit" value="<#Add#> <#Enrollments#>"></form>

<form action="/cgi-bin/repcard/evaldeled.pl" method="post" style="display:inline;">
<input type="submit" value="<#Edit#>/<#Delete#>"></form>

<form action="/cgi-bin/repcard/evalmove.pl" method="post" style="display:inline;">
<input type="submit" value="<#Move#>"></form>

<form action="/cgi-bin/repcard/syncmoodle.pl" method="post" style="display:inline;">
<input type="submit" value="<#Sync Moodle#>"></form>
<br>


<form action="/cgi-bin/repcard/rptcourse1.pl" method="post" style="display:inline;">
<input type="submit" value="<#Course#> <#Report#> 1"></form>

<form action="/cgi-bin/repcard/rptcourse2.pl" method="post" style="display:inline;">
<input type="submit" value="<#Course#> <#Report#> 2"></form>
<br>


<form action="/cgi-bin/repcard/rptenrolgrade.pl" method="post" style="display:inline;">
<input type="submit" value="<#Grade#>/<#Term#> <#Report#>"></form>

<form action="/cgi-bin/repcard/rptenrolstud.pl" method="post" style="display:inline;">
<input type="submit" value="<#Student#> <#Report#>"></form>
<br>


<form action="/cgi-bin/repcard/evaldelstud.pl" method="post" style="display:inline;">
<input type="submit" value="<#View#>/<#Delete#> <#Individual#>">
</form>

<!-- <form action="/cgi-bin/repcard/enrolview.pl" method="post">
<input type="submit" value="<#View Student Enrollments#>"></form>
-->
</div>

<h2>Sask Ed Courses</h2>

<div class="fmt">
<form action="/cgi-bin/sasked/sdsrpt1_local.pl" method="post" style="display:inline;">
<input type="submit" value="Report 1" title="Sask Ed Completed Courses - Summary, All Years"></form>

<form action="/cgi-bin/sasked/sdsrpt2_local.pl" method="post" style="display:inline;">
<input type="submit" value="Report 2" title="Sask Ed Completed Courses - Select Students"></form>

<form action="/cgi-bin/sasked/coursecodeview.pl" method="post" style="display:inline;">
<input type="submit" value="View Course Codes" title="View Sask Ed Course Codes"></form>
<span style="color:red;font-weight:bold;">NEW!</span>
<br>


<form action="/cgi-bin/sasked/checkcurrmarks_local.pl" method="post" style="display:inline;">
<input type="submit" value="Check Current Marks against SDS"></form>

<br>
<form action="/cgi-bin/sasked/checkgrad_local.pl" method="post" style="display:inline;">
<input type="submit" value="Check Graduation Requirements"></form>

<form action="/cgi-bin/attendance/rptCreditsEarned.pl" method="post" style="display:inline;">
  <input type="submit"
 title="A summary report showing student credit attainments grouped by their attendance (70%,50%-70%,<50%)"
	 value="Attendance/Credits Earned Report">
</form>


</div>


</td></tr></table>
</body></html>
